-- hds header_start
--
-- VHDL Entity work.comb_divider.symbol
--
-- Created:
--          by - root.UNKNOWN (XP)
--          at - 21:03:26 14. 05. 2003
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2001.5 (Build 170)
--
-- hds header_end
-- ---------------------------ENTITY DECLARATION--------------------------------
-- 
-------------------------------------------------------------------------------
LIBRARY IEEE; 
USE IEEE.std_logic_1164.all; 
USE IEEE.std_logic_arith.all; 


ENTITY comb_divider IS
   GENERIC( 
      DWIDTH : integer := 17
   );
   PORT( 
      dvdnd_i : IN     std_logic_vector (DWIDTH-1 DOWNTO 0); -- Dividend
      dvsor_i : IN     std_logic_vector (DWIDTH-1 DOWNTO 0); -- Divisor
      qutnt_o : OUT    std_logic_vector (DWIDTH-1 DOWNTO 0); -- Quotient
      rmndr_o : OUT    std_logic_vector (DWIDTH-1 DOWNTO 0)
   );

-- Declarations

END comb_divider ;

-- hds interface_end
--
-- VHDL Architecture work.comb_divider.rtl
--
-- Created:
--          by - root.UNKNOWN (XP)
--          at - 21:03:26 14. 05. 2003
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2001.5 (Build 170)
--

ARCHITECTURE rtl OF comb_divider IS

BEGIN

   --    rtl
   -- 
   --    purpose: Divide dvdnd_i through dvsor_i and deliver the result to qutnt_o
   --             and the remainder to rmndr_o.
   --    type   : combinational
   --    inputs : dvdnd_i, dvsor_i
   --    outputs: qutnt_o, rmndr_o
   --   
   ---------------------------------------------------------------------------
   p_divide : PROCESS (dvdnd_i, dvsor_i)
   ---------------------------------------------------------------------------

   -- Process declarations
   
       variable v_actl_dvdnd : unsigned(DWIDTH-1 downto 0);
       variable v_dffrnc     : unsigned(DWIDTH-1 downto 0);
    variable v_qutnt      : unsigned(DWIDTH-1 downto 0);
    
   


   BEGIN
      -- process p_divide
      v_actl_dvdnd := unsigned(dvdnd_i);
      l0: for i in DWIDTH-1 downto 0 LOOP
         -- If the divisor can be subtracted from this part of the dividend, then
         -- the corresponding bit of the quotient has to be 1, otherwise 0.
         IF  conv_std_logic_vector(v_actl_dvdnd(DWIDTH-1 downto i),DWIDTH) >=
                    dvsor_i  THEN
            -- Divisor can be subtracted
            v_qutnt(i) := '1';
            v_dffrnc := conv_unsigned(v_actl_dvdnd(DWIDTH-1 downto i),DWIDTH)
                      - unsigned(dvsor_i);
            -- As long as this is not the last step of calculation, shift the
            -- intermediate result.
            IF  i /= 0  THEN
               v_actl_dvdnd(DWIDTH-1 downto i) := v_dffrnc(DWIDTH-1-i downto 0);
               v_actl_dvdnd(i-1) := dvdnd_i(i-1);
            END IF;
         ELSE
            -- Divisor is greater than this part of the dividend.
            v_qutnt(i) := '0';
            v_dffrnc := conv_unsigned(v_actl_dvdnd(DWIDTH-1 downto i),DWIDTH);
         END IF;
      END LOOP l0;
      -- i
      
      rmndr_o <= std_logic_vector(v_dffrnc);
      qutnt_o <= std_logic_vector(v_qutnt);
   END PROCESS p_divide;


END rtl;
